(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     30068,       1038]
NotebookOptionsPosition[     27303,        937]
NotebookOutlinePosition[     27640,        952]
CellTagsIndexPosition[     27597,        949]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"f0", " ", "=", " ", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Rb", "^", "2"}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Rb", "^", "2"}], "+", 
      RowBox[{
       RowBox[{"Rb", "^", "2"}], " ", 
       RowBox[{"Deff", "^", "2"}], " ", 
       RowBox[{"t", "^", "2"}]}]}], ")"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.595925973627616*^9, 3.595926024338757*^9}}],

Cell[BoxData[
 SqrtBox[
  FractionBox[
   RowBox[{"1", "+", 
    SuperscriptBox["Rb", "2"]}], 
   RowBox[{"1", "+", 
    SuperscriptBox["Rb", "2"], "+", 
    RowBox[{
     SuperscriptBox["Deff", "2"], " ", 
     SuperscriptBox["Rb", "2"], " ", 
     SuperscriptBox["t", "2"]}]}]]]], "Output",
 CellChangeTimes->{3.595926025667*^9, 3.5959261842280273`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"param", " ", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Rb", "\[Rule]", 
     RowBox[{"D1", "/", "D0"}]}], ",", " ", 
    RowBox[{"Deff", " ", "->", " ", 
     RowBox[{"Sqrt", "[", 
      RowBox[{
       RowBox[{"D1", "^", "2"}], "+", 
       RowBox[{"D0", "^", "2"}]}], "]"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.595926314482622*^9, 3.595926325976609*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Rb", "\[Rule]", 
    FractionBox["D1", "D0"]}], ",", 
   RowBox[{"Deff", "\[Rule]", 
    SqrtBox[
     RowBox[{
      SuperscriptBox["D0", "2"], "+", 
      SuperscriptBox["D1", "2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{3.595926327154772*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"f0", "/.", "param"}], "]"}]], "Input",
 CellChangeTimes->{{3.595926030994298*^9, 3.595926089818026*^9}, {
  3.5959262559894648`*^9, 3.595926260474937*^9}, {3.595926334496995*^9, 
  3.595926335005987*^9}}],

Cell[BoxData[
 SqrtBox[
  FractionBox["1", 
   RowBox[{"1", "+", 
    RowBox[{
     SuperscriptBox["D1", "2"], " ", 
     SuperscriptBox["t", "2"]}]}]]]], "Output",
 CellChangeTimes->{{3.595926069347397*^9, 3.595926090644937*^9}, 
   3.595926188287231*^9, 3.595926261276557*^9, 3.5959263357222223`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Deff", "^", "2"}], " ", 
     RowBox[{"t", "^", "2"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Rb", "^", "2"}], "+", 
       RowBox[{
        RowBox[{"Rb", "^", "2"}], " ", 
        RowBox[{"Deff", "^", "2"}], " ", 
        RowBox[{"t", "^", "2"}]}]}], ")"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5959261016656437`*^9, 3.595926151958776*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["Deff", "2"], " ", 
   SuperscriptBox["t", "2"]}], 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"], "+", 
     RowBox[{
      SuperscriptBox["Deff", "2"], " ", 
      SuperscriptBox["Rb", "2"], " ", 
      SuperscriptBox["t", "2"]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.5959261549834623`*^9, 3.595926191822867*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"f1", "/.", "param"}], "]"}]], "Input",
 CellChangeTimes->{{3.595926203560082*^9, 3.595926226230337*^9}, {
  3.595926270972595*^9, 3.595926276986402*^9}, {3.595926341820969*^9, 
  3.595926342189616*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["D0", "2"], " ", 
   SuperscriptBox["t", "2"]}], 
  RowBox[{"2", "+", 
   RowBox[{"2", " ", 
    SuperscriptBox["D1", "2"], " ", 
    SuperscriptBox["t", "2"]}]}]]], "Output",
 CellChangeTimes->{3.5959262271803293`*^9, 3.595926277723551*^9, 
  3.595926342835534*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f2", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Rb", "^", "2"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Rb", "^", "2"}], "+", 
        RowBox[{
         RowBox[{"Rb", "^", "2"}], " ", 
         RowBox[{"Deff", "^", "2"}], " ", 
         RowBox[{"t", "^", "2"}]}]}], ")"}]}], ")"}], "^", 
    RowBox[{"(", 
     RowBox[{"3", "/", "2"}], ")"}]}], 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Deff", "^", "2"}], " ", 
        RowBox[{"t", "^", "2"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Rb", "^", "2"}], "+", 
        RowBox[{
         RowBox[{"Rb", "^", "2"}], " ", 
         RowBox[{"Deff", "^", "2"}], " ", 
         RowBox[{"t", "^", "2"}]}]}], ")"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.595926344677051*^9, 3.59592650676553*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox[
     RowBox[{"1", "+", 
      SuperscriptBox["Rb", "2"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["Rb", "2"], "+", 
      RowBox[{
       SuperscriptBox["Deff", "2"], " ", 
       SuperscriptBox["Rb", "2"], " ", 
       SuperscriptBox["t", "2"]}]}]], ")"}], 
   RowBox[{"3", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["Deff", "2"], " ", 
      SuperscriptBox["t", "2"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["Rb", "2"], "+", 
      RowBox[{
       SuperscriptBox["Deff", "2"], " ", 
       SuperscriptBox["Rb", "2"], " ", 
       SuperscriptBox["t", "2"]}]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.595926510020307*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f2S", " ", "=", " ", 
  RowBox[{"Simplify", "[", 
   RowBox[{"f2", "/.", "param"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.595926527897192*^9, 3.5959265395268803`*^9}, {
  3.595926573960384*^9, 3.595926576502159*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox["1", 
     RowBox[{"1", "+", 
      RowBox[{
       SuperscriptBox["D1", "2"], " ", 
       SuperscriptBox["t", "2"]}]}]], ")"}], 
   RowBox[{"5", "/", "2"}]], " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{
     SuperscriptBox["D0", "2"], " ", 
     SuperscriptBox["t", "2"]}], "+", 
    RowBox[{
     SuperscriptBox["D1", "2"], " ", 
     SuperscriptBox["t", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.595926540331861*^9, 3.5959265772154627`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"f2S", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"D0", "^", "2"}], " ", 
          RowBox[{"t", "^", "2"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           RowBox[{"D1", "^", "2"}], " ", 
           RowBox[{"t", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"D1", "^", "2"}], " ", 
         RowBox[{"t", "^", "2"}]}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"3", "/", "2"}], ")"}]}]}]}], ",", " ", 
   RowBox[{"Assumptions", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"D0", ">", "0"}], ",", 
      RowBox[{"D1", ">", "0"}], ",", " ", 
      RowBox[{"t", "\[GreaterEqual]", "0"}]}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.595926580925435*^9, 3.595926699382821*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.595926662735504*^9, 3.5959267005264053`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f3", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"Rb", "^", "2"}]}], ")"}], 
   RowBox[{"D0", "^", "2"}]}]}]], "Input",
 CellChangeTimes->{{3.595926935871663*^9, 3.595926961537612*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["D0", "2"], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["Rb", "2"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.595926962620351*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"f3", "/.", "param"}], "]"}]], "Input",
 CellChangeTimes->{{3.595926964686531*^9, 3.595926972688628*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["D0", "2"], "+", 
  SuperscriptBox["D1", "2"]}]], "Output",
 CellChangeTimes->{3.595926973283683*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", "nu"}], " ", "t"}], "]"}], "-", "1", "+", 
      RowBox[{"nu", " ", "t"}]}], ")"}], "/", 
    RowBox[{"nu", "^", "2"}]}], ",", 
   RowBox[{"nu", "\[Rule]", "0"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.595927487422308*^9, 3.595927535823647*^9}}],

Cell[BoxData[
 FractionBox[
  SuperscriptBox["t", "2"], "2"]], "Output",
 CellChangeTimes->{3.5959275367424517`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PZFs", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"1", "/", "3"}], "+", 
     RowBox[{
      RowBox[{"2", "/", "3"}], " ", "f2", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"-", "f1"}], "]"}]}]}], ")"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Deff", "^", "2"}], "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Rb", "^", "2"}]}], ")"}], 
      RowBox[{"D0", "^", "2"}]}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.5959312989231358`*^9, 3.595931381039365*^9}, {
  3.5959314828699923`*^9, 3.59593152054951*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "3"], "+", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       SuperscriptBox["D0", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["Rb", "2"]}], ")"}], " ", 
       SuperscriptBox["t", "2"]}], 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["Rb", "2"], "+", 
         RowBox[{
          SuperscriptBox["D0", "2"], " ", 
          SuperscriptBox["Rb", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["Rb", "2"]}], ")"}], " ", 
          SuperscriptBox["t", "2"]}]}], ")"}]}]]}]], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{"1", "+", 
       SuperscriptBox["Rb", "2"]}], 
      RowBox[{"1", "+", 
       SuperscriptBox["Rb", "2"], "+", 
       RowBox[{
        SuperscriptBox["D0", "2"], " ", 
        SuperscriptBox["Rb", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox["Rb", "2"]}], ")"}], " ", 
        SuperscriptBox["t", "2"]}]}]], ")"}], 
    RowBox[{"3", "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     FractionBox[
      RowBox[{
       SuperscriptBox["D0", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["Rb", "2"]}], ")"}], " ", 
       SuperscriptBox["t", "2"]}], 
      RowBox[{"1", "+", 
       SuperscriptBox["Rb", "2"], "+", 
       RowBox[{
        SuperscriptBox["D0", "2"], " ", 
        SuperscriptBox["Rb", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox["Rb", "2"]}], ")"}], " ", 
        SuperscriptBox["t", "2"]}]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.595931383563058*^9, 3.595931522044511*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<test.txt\>\"", ",", "tab", ",", " ", "\"\<Table\>\""}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.595931389114702*^9, 3.59593139062152*^9}, {
  3.595931648526497*^9, 3.595931743164625*^9}, {3.595932071532652*^9, 
  3.595932073666566*^9}, {3.595932183303565*^9, 3.595932202497183*^9}, {
  3.595932307301804*^9, 3.5959323105235243`*^9}, {3.5959323558233232`*^9, 
  3.59593238424125*^9}, {3.595932511134659*^9, 3.595932534244995*^9}, {
  3.595932575925478*^9, 3.595932577442565*^9}, {3.595932706537533*^9, 
  3.595932706956338*^9}}],

Cell[BoxData["\<\"test.txt\"\>"], "Output",
 CellChangeTimes->{
  3.5959322034308767`*^9, 3.59593231220931*^9, {3.5959323574444304`*^9, 
   3.595932385006859*^9}, 3.595932535345787*^9, 3.5959325783683767`*^9, 
   3.5959327078260727`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tab", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"PZFs", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"D0", "\[Rule]", "0.649"}], ",", " ", 
          RowBox[{"Rb", "\[Rule]", "0.43"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "8", ",", "0.01"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5959326175365353`*^9, 3.5959326970147543`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PTFs", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"f0", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", "f1"}], "]"}]}], ")"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Deff", "^", "2"}], "\[Rule]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Rb", "^", "2"}]}], ")"}], 
        RowBox[{"D0", "^", "2"}]}]}], "}"}]}], ")"}], 
   RowBox[{"Cos", "[", 
    RowBox[{
     RowBox[{"2", "Pi", " ", "t"}], "+", 
     RowBox[{"Pi", "/", "4"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.59593316256579*^9, 3.595933459165799*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["D0", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"]}], ")"}], " ", 
      SuperscriptBox["t", "2"]}], 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"], "+", 
        RowBox[{
         SuperscriptBox["D0", "2"], " ", 
         SuperscriptBox["Rb", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["Rb", "2"]}], ")"}], " ", 
         SuperscriptBox["t", "2"]}]}], ")"}]}]]}]], " ", 
  SqrtBox[
   FractionBox[
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"]}], 
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"], "+", 
     RowBox[{
      SuperscriptBox["D0", "2"], " ", 
      SuperscriptBox["Rb", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"]}], ")"}], " ", 
      SuperscriptBox["t", "2"]}]}]]], " ", 
  RowBox[{"Cos", "[", 
   RowBox[{
    FractionBox["\[Pi]", "4"], "+", 
    RowBox[{"2", " ", "\[Pi]", " ", "t"}]}], "]"}]}]], "Output",
 CellChangeTimes->{{3.595933248341262*^9, 3.595933279161812*^9}, 
   3.595933340671547*^9, {3.595933381303545*^9, 3.595933403154574*^9}, 
   3.595933460092004*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tab2", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"PTFs", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"D0", "\[Rule]", "0.649"}], ",", " ", 
          RowBox[{"Rb", "\[Rule]", "0.43"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "8", ",", "0.01"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.595933471492853*^9, 3.595933474820298*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<NK_TF_static_Mathematic.dat\>\"", ",", "tab2", ",", " ", 
   "\"\<Table\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.59593349961754*^9, 3.595933510890025*^9}, 
   3.5959336055042057`*^9}],

Cell[BoxData["\<\"NK_TF_static_Mathematic.dat\"\>"], "Output",
 CellChangeTimes->{3.595933511610558*^9, 3.595933606126593*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Theta", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "nu"}], " ", "t"}], "]"}], "-", "1", "+", 
     RowBox[{"nu", " ", "t"}]}], ")"}], "/", 
   RowBox[{"nu", "^", "2"}]}]}]], "Input",
 CellChangeTimes->{{3.595934262045046*^9, 3.595934302983852*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "1"}], "+", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "nu"}], " ", "t"}]], "+", 
   RowBox[{"nu", " ", "t"}]}], 
  SuperscriptBox["nu", "2"]]], "Output",
 CellChangeTimes->{3.595934304278636*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"f5", " ", "=", " ", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Rb", "^", "2"}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Rb", "^", "2"}], "+", 
      RowBox[{"4", " ", 
       RowBox[{"Rb", "^", "2"}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Rb", "^", "2"}]}], ")"}], 
       RowBox[{"D0", "^", "2"}], " ", "Theta"}]}], ")"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"f6", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Rb", "^", "2"}]}], ")"}], 
     RowBox[{"D0", "^", "2"}], " ", "Theta"}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"Rb", "^", "2"}], "+", 
     RowBox[{"4", 
      RowBox[{"Rb", "^", "2"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Rb", "^", "2"}]}], ")"}], 
      RowBox[{"D0", "^", "2"}], " ", "Theta"}]}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.595934324705645*^9, 3.5959344414949923`*^9}}],

Cell[BoxData[
 SqrtBox[
  FractionBox[
   RowBox[{"1", "+", 
    SuperscriptBox["Rb", "2"]}], 
   RowBox[{"1", "+", 
    SuperscriptBox["Rb", "2"], "+", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["D0", "2"], " ", 
      SuperscriptBox["Rb", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "nu"}], " ", "t"}]], "+", 
        RowBox[{"nu", " ", "t"}]}], ")"}]}], 
     SuperscriptBox["nu", "2"]]}]]]], "Output",
 CellChangeTimes->{3.595934442574997*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   SuperscriptBox["D0", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "nu"}], " ", "t"}]], "+", 
     RowBox[{"nu", " ", "t"}]}], ")"}]}], 
  RowBox[{
   SuperscriptBox["nu", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"], "+", 
     FractionBox[
      RowBox[{"4", " ", 
       SuperscriptBox["D0", "2"], " ", 
       SuperscriptBox["Rb", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["Rb", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "nu"}], " ", "t"}]], "+", 
         RowBox[{"nu", " ", "t"}]}], ")"}]}], 
      SuperscriptBox["nu", "2"]]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.595934442614571*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PZFd", " ", "=", " ", 
  RowBox[{"f5", " ", 
   RowBox[{"Exp", "[", 
    RowBox[{"-", "f6"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.595934450067131*^9, 3.595934466249145*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"2", " ", 
      SuperscriptBox["D0", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "nu"}], " ", "t"}]], "+", 
        RowBox[{"nu", " ", "t"}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox["nu", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"], "+", 
        FractionBox[
         RowBox[{"4", " ", 
          SuperscriptBox["D0", "2"], " ", 
          SuperscriptBox["Rb", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["Rb", "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"-", "nu"}], " ", "t"}]], "+", 
            RowBox[{"nu", " ", "t"}]}], ")"}]}], 
         SuperscriptBox["nu", "2"]]}], ")"}]}]]}]], " ", 
  SqrtBox[
   FractionBox[
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"]}], 
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"], "+", 
     FractionBox[
      RowBox[{"4", " ", 
       SuperscriptBox["D0", "2"], " ", 
       SuperscriptBox["Rb", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["Rb", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "nu"}], " ", "t"}]], "+", 
         RowBox[{"nu", " ", "t"}]}], ")"}]}], 
      SuperscriptBox["nu", "2"]]}]]]}]], "Output",
 CellChangeTimes->{3.5959344683192244`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tab3", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"PZFd", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"D0", "\[Rule]", "0.649"}], ",", " ", 
          RowBox[{"Rb", "\[Rule]", "0.43"}], ",", " ", 
          RowBox[{"nu", "\[Rule]", "0.73"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "8", ",", "0.01"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5959344722663727`*^9, 3.595934569538118*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<NK_ZF_dynamic_Mathematic.dat\>\"", ",", "tab3", ",", " ", 
   "\"\<Table\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.5959345844950523`*^9, 3.59593459621416*^9}}],

Cell[BoxData["\<\"NK_ZF_dynamic_Mathematic.dat\"\>"], "Output",
 CellChangeTimes->{3.595934597107378*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PTFd", " ", "=", " ", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Rb", "^", "2"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Rb", "^", "2"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"Rb", "^", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Rb", "^", "2"}]}], ")"}], 
        RowBox[{"D0", "^", "2"}], " ", "Theta"}]}], ")"}]}], "]"}], 
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Rb", "^", "2"}]}], ")"}], 
        RowBox[{"D0", "^", "2"}], " ", "Theta"}], ")"}]}], "/", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Rb", "^", "2"}], "+", 
       RowBox[{"2", 
        RowBox[{"Rb", "^", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Rb", "^", "2"}]}], ")"}], 
        RowBox[{"D0", "^", "2"}], " ", "Theta"}]}], ")"}]}], "]"}], 
   RowBox[{"Cos", "[", 
    RowBox[{
     RowBox[{"2", "Pi", " ", "t"}], "+", 
     RowBox[{"Pi", "/", "4"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.595934795577188*^9, 3.595934885146266*^9}, {
  3.595934925987093*^9, 3.595934934793614*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["D0", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "nu"}], " ", "t"}]], "+", 
        RowBox[{"nu", " ", "t"}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox["nu", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["Rb", "2"], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["D0", "2"], " ", 
          SuperscriptBox["Rb", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["Rb", "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"-", "nu"}], " ", "t"}]], "+", 
            RowBox[{"nu", " ", "t"}]}], ")"}]}], 
         SuperscriptBox["nu", "2"]]}], ")"}]}]]}]], " ", 
  SqrtBox[
   FractionBox[
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"]}], 
    RowBox[{"1", "+", 
     SuperscriptBox["Rb", "2"], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["D0", "2"], " ", 
       SuperscriptBox["Rb", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["Rb", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "nu"}], " ", "t"}]], "+", 
         RowBox[{"nu", " ", "t"}]}], ")"}]}], 
      SuperscriptBox["nu", "2"]]}]]], " ", 
  RowBox[{"Cos", "[", 
   RowBox[{
    FractionBox["\[Pi]", "4"], "+", 
    RowBox[{"2", " ", "\[Pi]", " ", "t"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.59593488578555*^9, 3.5959349356123943`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tab4", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"PTFd", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"D0", "\[Rule]", "0.649"}], ",", " ", 
          RowBox[{"Rb", "\[Rule]", "0.43"}], ",", " ", 
          RowBox[{"nu", "\[Rule]", "0.73"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "8", ",", "0.01"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.595934893369198*^9, 3.595934915189219*^9}, {
  3.5959349471523647`*^9, 3.595934968172822*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<NK_TF_dynamic_Mathematic.dat\>\"", ",", "tab4", ",", " ", 
   "\"\<Table\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.5959349769862843`*^9, 3.595934981506559*^9}}],

Cell[BoxData["\<\"NK_TF_dynamic_Mathematic.dat\"\>"], "Output",
 CellChangeTimes->{3.595934982107398*^9}]
}, Open  ]]
},
WindowSize->{640, 750},
WindowMargins->{{Automatic, 560}, {Automatic, 0}},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 474, 14, 32, "Input"],
Cell[1044, 38, 355, 11, 58, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1436, 54, 394, 11, 32, "Input"],
Cell[1833, 67, 302, 10, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2172, 82, 256, 5, 32, "Input"],
Cell[2431, 89, 302, 8, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2770, 102, 520, 16, 32, "Input"],
Cell[3293, 120, 424, 13, 56, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3754, 138, 254, 5, 32, "Input"],
Cell[4011, 145, 323, 10, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4371, 160, 1001, 32, 55, "Input"],
Cell[5375, 194, 783, 26, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6195, 225, 243, 5, 32, "Input"],
Cell[6441, 232, 540, 18, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7018, 255, 993, 31, 77, "Input"],
Cell[8014, 288, 94, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8145, 294, 235, 7, 32, "Input"],
Cell[8383, 303, 191, 6, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8611, 314, 156, 3, 32, "Input"],
Cell[8770, 319, 142, 4, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8949, 328, 404, 12, 32, "Input"],
Cell[9356, 342, 116, 3, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9509, 350, 619, 19, 32, "Input"],
Cell[10131, 371, 1852, 58, 118, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12020, 434, 583, 10, 32, "Input"],
Cell[12606, 446, 237, 4, 31, "Output"]
}, Open  ]],
Cell[12858, 453, 518, 15, 32, "Input"],
Cell[CellGroupData[{
Cell[13401, 472, 658, 21, 55, "Input"],
Cell[14062, 495, 1332, 41, 78, "Output"]
}, Open  ]],
Cell[15409, 539, 515, 15, 32, "Input"],
Cell[CellGroupData[{
Cell[15949, 558, 246, 6, 32, "Input"],
Cell[16198, 566, 126, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16361, 572, 347, 10, 32, "Input"],
Cell[16711, 584, 278, 9, 49, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17026, 598, 1097, 34, 77, "Input"],
Cell[18126, 634, 685, 22, 80, "Output"],
Cell[18814, 658, 1057, 34, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19908, 697, 204, 5, 32, "Input"],
Cell[20115, 704, 1873, 58, 106, "Output"]
}, Open  ]],
Cell[22003, 765, 573, 16, 55, "Input"],
Cell[CellGroupData[{
Cell[22601, 785, 221, 5, 32, "Input"],
Cell[22825, 792, 105, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22967, 798, 1311, 40, 77, "Input"],
Cell[24281, 840, 2014, 62, 155, "Output"]
}, Open  ]],
Cell[26310, 905, 622, 17, 55, "Input"],
Cell[CellGroupData[{
Cell[26957, 926, 222, 5, 32, "Input"],
Cell[27182, 933, 105, 1, 31, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
